package main;

public class EdgeElement {

	public EdgeElement(){
		hasConnect = false;
	}
	public EdgeElement(String e1, String e2, double w){
		edge1 = e1;
		edge2 = e2;
		hasConnect = true;
		weight = w;
	}
	public EdgeElement(String e1, String e2, boolean hasConn){
		this(e1, e2);
		if(hasConn){
			hasConnect = hasConn;
			weight = 1.0;
		}
	}
	public EdgeElement(String e1, String e2){
		edge1 = e1;
		edge2 = e2;
		hasConnect = false;
		weight = 0.0;
	}
	
	
	private boolean hasConnect;
	private String edge1;
	private String edge2;
	private double weight;
	
	
	
	public boolean hasConnect(){
		return hasConnect;
	}
	public String getElement(String s) {
		
		return edge1 + s + edge2;
	}
	public String getElement() {
		return getElement("|");
	}
	public String getElement1(){
		return edge1;
	}
	public String getElement2(){
		return edge2;
	}
	public boolean match(String s){
		return s.equals(edge1) || s.equals(edge2);
	}
	public String getAnotherElement(String s){
		if(s.equals(edge1)){ return edge2; }
		if(s.equals(edge2)){ return edge1; }
		return "";
	}
	public boolean matchAll(String s1, String s2){
		if( (s1.equals(edge1) && s2.equals(edge2))||(s1.equals(edge2) && s2.equals(edge1)) ){
			return true;
		} else {
			return false;
		}
	}
	
}
