package util;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import main.Complex;
import main.FilePath;
import main.GeneMatch;
import main.MatrixOfBioinfo;
import main.RuningMain;
import main.testGene;

public class ComplexInfoStatistics {
	
	public void doSomething(){
		
		//can shu
		int cs = 500;
		double p = 0.2;
		
		//wen jian
		List<GeneMatch> lgm = testGene.getMatchList(FilePath.filePathMatch);
		List<Complex> lcm = RuningMain.getComplexCYC(FilePath.filePathComplexCYC);
		MatrixOfBioinfo m = RuningMain.getMatrixByInit(FilePath.filePathPPI);

		ComplexBuilderUtil cb = new ComplexBuilderUtil(m, lcm);
		
		// luo ji
		List<Complex> lAllrc = new ArrayList<Complex>();
		List<Complex> lCrc = new ArrayList<Complex>();
		List<Complex> lACrc25 = new ArrayList<Complex>();
		List<Complex> lACrc50 = new ArrayList<Complex>();
		List<Complex> lACrc75 = new ArrayList<Complex>();
		List<Complex> lAndrc = new ArrayList<Complex>();
		
		for(int i = 0; i < cs; i++){
			//lAllrc.add(cb.getAllRandomComplex(p));
			//lCrc.add(cb.getCYCRandomComplex(p));
			//lACrc25.add(cb.getCYCandAllRandomComplex(0.25, p));
			//lACrc50.add(cb.getCYCandAllRandomComplex(0.5, p));
			//lACrc75.add(cb.getCYCandAllRandomComplex(0.75, p));
			//lAndrc.add(cb.getAndRandomComplex(0.5));
			
			lAllrc.add(cb.getAllRandomComplex());
			lCrc.add(cb.getCYCRandomComplex());
			lACrc25.add(cb.getCYCandAllRandomComplex(0.25));
			lACrc50.add(cb.getCYCandAllRandomComplex(0.5));
			lACrc75.add(cb.getCYCandAllRandomComplex(0.75));
			lAndrc.add(cb.getAndRandomComplex(0.5));
		}
		
		something(lAllrc, lgm);
		something(lCrc, lgm);
		something(lACrc25, lgm);
		something(lACrc50, lgm);
		something(lACrc75, lgm);
		something(lAndrc, lgm);
		something(lcm, lgm);
		
		//MatrixOfBioinfo mv = getValueMatrix(m, lgm);
		//mv.showMatrix();

		
		
	}
	
	// ܻımatrixֵ
	public static MatrixOfBioinfo getValueMatrix(MatrixOfBioinfo m, List<GeneMatch> lgm){
		
		for(int i = 0; i < m.size(); i++){
			String n1 = m.getTitleRow().get(i).getName();
			for(int j = i+1; j < m.size(); j++){
				if(m.getElementValue(i, j) > -1){
					
					String n2 = m.getTitleRow().get(j).getName();
					
					int ct = 0;
					GeneMatch g = null;
					for(GeneMatch gm : lgm){
						if(gm.getProtein().equals(n1) || gm.getProtein().equals(n2)){
							ct++;
							if(ct >= 2){
								
								double v = g.getPerEva().getMatchValue(gm.getPerEva(), 2);
								
								m.getElement(i, j).setValue(v);
								m.getElement(j, i).setValue(v);
								//System.out.println(m.getElementValue(j, i));
								//mp2.getElement(i, j).setValue(g.getPerEva().getMatchValue(gm.getPerEva(), 3));
								//mp3.getElement(i, j).setValue(g.getPerEva().getMatchValue(gm.getPerEva(), 4));
								//ma1.getElement(i, j).setValue(g.getAmpEva().getMatchValue(gm.getAmpEva(), 2));
								//ma2.getElement(i, j).setValue(g.getAmpEva().getMatchValue(gm.getAmpEva(), 3));
								//ma3.getElement(i, j).setValue(g.getAmpEva().getMatchValue(gm.getAmpEva(), 4));
							} else {
								g = gm;
							}
						}
					}
					
				}
				
			}
			
			
		}
		
		return m;
	}
	
	public static void something(List<Complex> lc, List<GeneMatch> lgm){
		
		double zzh = 0;
		double zfc = 0;
		double jsq = 0;
		List<Double> lvAvg = new ArrayList<Double>();
		List<Double> lvFc = new ArrayList<Double>();
		for(Complex c : lc){
			List<Double> lv = new ArrayList<Double>();
			for(int i = 0; i < c.getProteinList().size(); i++){
				String n1 = c.getProteinList().get(i);
				for(int j = i+1; j < c.getProteinList().size(); j++){
					//
					String n2 = c.getProteinList().get(j);
					
					int ct = 0;
					GeneMatch g = null;
					for(GeneMatch gm : lgm){
						if(gm.getProtein().equals(n1) || gm.getProtein().equals(n2)){
							ct++;
							if(ct >= 2){
								double v = g.getPerEva().getMatchValue(gm.getPerEva(), 2);
								//double v = g.getAmpEva().getMatchValue(gm.getAmpEva(), 4);
								//mp2.getElement(i, j).setValue(g.getPerEva().getMatchValue(gm.getPerEva(), 3));
								//mp3.getElement(i, j).setValue(g.getPerEva().getMatchValue(gm.getPerEva(), 4));
								//ma1.getElement(i, j).setValue(g.getAmpEva().getMatchValue(gm.getAmpEva(), 2));
								//ma2.getElement(i, j).setValue(g.getAmpEva().getMatchValue(gm.getAmpEva(), 3));
								//ma3.getElement(i, j).setValue(g.getAmpEva().getMatchValue(gm.getAmpEva(), 4));
								lv.add(v);
								break;
							} else {
								g = gm;
							}
						}
						
					}//
					
				}
			}
			
			if(lv.size() < 1){
				System.out.println("---");
				continue;
			}
			
			double zonghe = 0;
			for(Double d : lv){
				zonghe += d;
			}
			double fangchahe = 0;
			for(Double d : lv){
				fangchahe += ( (d - zonghe/lv.size()) * (d - zonghe/lv.size()) );
			}
			lvAvg.add(zonghe/lv.size());
			lvFc.add(fangchahe/lv.size());
			zzh += zonghe/lv.size();
			zfc += fangchahe/lv.size();
			jsq++;
			
			//System.out.println(zonghe/lv.size());
			//System.out.println("junzhi--" + zonghe/lv.size() + " fangcha--" + fangchahe/lv.size());
		}
		
		yixietongji(lvAvg, zzh/jsq);
		yixietongji(lvFc, zfc/jsq);
		System.out.println("---------------------------");
	}
	
	public static double calComplexValue(Complex c, List<GeneMatch> lgm){
		
		List<Double> lv = new ArrayList<Double>();
		for(int i = 0; i < c.getProteinList().size(); i++){
			String n1 = c.getProteinList().get(i);
			for(int j = i+1; j < c.getProteinList().size(); j++){
				//
				String n2 = c.getProteinList().get(j);
				
				int ct = 0;
				GeneMatch g = null;
				for(GeneMatch gm : lgm){
					if(gm.getProtein().equals(n1) || gm.getProtein().equals(n2)){
						ct++;
						if(ct >= 2){
							double v = g.getPerEva().getMatchValue(gm.getPerEva(), 2);
							//double v = g.getAmpEva().getMatchValue(gm.getAmpEva(), 4);
							//mp2.getElement(i, j).setValue(g.getPerEva().getMatchValue(gm.getPerEva(), 3));
							//mp3.getElement(i, j).setValue(g.getPerEva().getMatchValue(gm.getPerEva(), 4));
							//ma1.getElement(i, j).setValue(g.getAmpEva().getMatchValue(gm.getAmpEva(), 2));
							//ma2.getElement(i, j).setValue(g.getAmpEva().getMatchValue(gm.getAmpEva(), 3));
							//ma3.getElement(i, j).setValue(g.getAmpEva().getMatchValue(gm.getAmpEva(), 4));
							lv.add(v);
							break;
						} else {
							g = gm;
						}
					}
					
				}//
				
			}
		}
		
		double zonghe = 0;
		for(Double d : lv){
			zonghe += d;
		}
		double fangchahe = 0;
		for(Double d : lv){
			fangchahe += ( (d - zonghe/lv.size()) * (d - zonghe/lv.size()) );
		}
		
//		System.out.println("size : " + c.getProteinList().size());
//		System.out.println("avg : " + zonghe/lv.size());
//		System.out.println("fangcha : " + fangchahe/lv.size());
		
		//out top 50
//		Collections.sort(lv);
//		Collections.reverse(lv);
//		for(int i = 0; i < 500; i++){
//			System.out.println(lv.get(i) + "-------" + i);
//		}
//		int i96 = 0;
//		int i88 = 0;
//		for(Double d : lv){
//			if(d > 88.7725){
//				i88++;
//				if(d > 96.15){
//					i96++;
//				}
//			}
//		}
//		System.out.println("***  >88 : " + i88 + "  >96 : " + i96);
		
//		yixietongji(lv, 88.772513);
//		if(lv.size() > 2)                   //dddd 723
//		System.out.println(zonghe/lv.size() + "	" + fangchahe/lv.size());//ddd
		return new Double(zonghe/lv.size());
	}
	
	public static void showComplexEachInteractionValue_v1(){
		
		int num = 10000;
		
		List<GeneMatch> lgm = testGene.getMatchList(FilePath.filePathMatch);
		List<Complex> lcm = RuningMain.getComplexCYC(FilePath.filePathComplexCYC);
		MatrixOfBioinfo m = RuningMain.getMatrixByInit(FilePath.filePathPPI);

		ComplexBuilderUtil cb = new ComplexBuilderUtil(m, lcm);
		
		//
		List<Complex> lc = new ArrayList<Complex>();
		for(int i = 0; i < num; i++){
			//set test what complex
			
			Complex c = cb.getCYCAddRandomProtein(1);
			if(c.getProteinList().size() > 3)
			lc.add(c);
//			lc.add(cb.getAllRandomComplex());
		}
		
		// some param
		int ct = 0; //zong ge shu
		int dayu = 0; // fvalue bian da de geshu
		int tt = 0; // zhi da fv da  de geshu
		
		
		
		for(Complex c : lc){
			c.match(lcm);
			double ip = c.getPValue();
			
			double init = calComplexValue(c, lgm);//
			Complex cd = deleteOneProtein(c, lgm);
			double now = calComplexValue(cd, lgm);//
//			System.out.println("init : " + init + "  now : " + now);
			if(now >= init){
				dayu++;
			}
			
			cd.match(lcm);
			System.out.println(cd.getPrecise() + "--" + cd.getRecall() + "--" + cd.getPValue() + "** " + ip);
			if(cd.getPValue() > ip){
				ct++;
				if(now >= init){
					tt++;
				}
			}
		}
		
		System.out.println(lc.size() + "------ good is " + ct);
		System.out.println("------ dayu is " + dayu);
		System.out.println("------ tt is " + tt);
		
	}
	public static Complex deleteOneProtein(Complex c, List<GeneMatch> lgm){
		//double init = calComplexValue(c, lgm);
		
		double max = 0.0;
		Complex cm = c;
//		System.out.println(c + "--" + c.getProteinList().size()); //---
		for(String s : c.getProteinList()){
			
			List<String> l = new ArrayList<String>();
			for(String si : c.getProteinList()){
				if(!si.equals(s)){
					l.add(si);
				}
			}
			Complex ci = new Complex(l);
			double vi = calComplexValue(ci, lgm);
			
			if(vi > max){
				max = vi;
				cm = ci;
			}
		}
		//System.out.println("init : " + init + "  now : " + max);
		
		return cm;
	}
	
	public static void showComplexEachInteractionValue_v2(){
		
		int num = 1000;
		
		List<GeneMatch> lgm = testGene.getMatchList(FilePath.filePathMatch);
		List<Complex> lcm = RuningMain.getComplexCYC(FilePath.filePathComplexCYC);
		MatrixOfBioinfo m = RuningMain.getMatrixByInit(FilePath.filePathPPI);

		ComplexBuilderUtil cb = new ComplexBuilderUtil(m, lcm);
		
		//
		List<Complex> lc = new ArrayList<Complex>();
		for(int i = 0; i < num; i++){
			//set test what complex
//			Complex c = cb.getCYCAddRandomProtein(0);
//			if(c.getProteinList().size() > 2)
//			lc.add(c);
			lc.add(cb.getAllRandomComplex());
		}
		
		//
//		List<Double> ld = new ArrayList<Double>();
		
		for(Complex c : lc){
			//c.match(lcm);
			double iv = c.getPValue();
			double ip = c.getPrecise();
			double ir = c.getRecall();

			double init = calComplexValue(c, lgm);//
			
//			System.out.println(ip + "	" + init);
//			ld.add(init);
		}
//		yixietongji(ld);
		
	}
	
	
	public static void yixietongji(List<Double> ld, double junzhi){
		
		double v0 = 0;
		double v10 = 0;
		double v25 = 0;
		double v50 = 0;
		double v75 = 0;
		double v100 = 0;
		double v125 = 0;
		double v150 = 0;
		double v200 = 0;
		double v300 = 0;
		double v300p = 0;
		
		for(Double d : ld){
			if(d < 0.00001){
				v0++;
			} else if(d / junzhi < 0.1){
				v10++;
			} else if(d / junzhi < 0.25){
				v25++;
			} else if(d / junzhi < 0.50){
				v50++;
			} else if(d / junzhi < 0.75){
				v75++;
			} else if(d / junzhi < 1){
				v100++;
			} else if(d / junzhi < 1.25){
				v125++;
			} else if(d / junzhi < 1.5){
				v150++;
			} else if(d / junzhi < 2){
				v200++;
			} else if(d / junzhi < 3){
				v300++;
			} else {
				v300p++;
			}
		}
		
		//System.out.println("0 10 25 50 75 100 125 150 200 300 300+");
		System.out.println("-----yixietongji-----");
		System.out.println("avg : " + junzhi);
		System.out.println("v0    : " + v0);
		System.out.println("v10   : " + v10);
		System.out.println("v25   : " + v25);
		System.out.println("v50   : " + v50);
		System.out.println("v75   : " + v75);
		System.out.println("v100  : " + v100);
		System.out.println("v125  : " + v125);
		System.out.println("v150  : " + v150);
		System.out.println("v200  : " + v200);
		System.out.println("v300  : " + v300);
		System.out.println("v300+ : " + v300p);
		System.out.println("-----yixietongji----end-");
	}
	public static void yixietongji(List<Double> ld){
		Double zh = 0.0;
		for(Double d : ld){
			zh += d;
		}
		yixietongji(ld, (zh/ld.size()));
	}
}
