package calculate;

import java.util.ArrayList;
import java.util.List;

public class EMAmplitude extends ModelOfEvaluate {
	
	public EMAmplitude(List<Double> l){
		lgv = l;
		listAmplitude = new ArrayList<Double>();
		for(int i = 0; i < l.size() - 1; i++){
			listAmplitude.add(l.get(i+1) - l.get(i));
		}
	}
	
	private List<Double> lgv;
	
	private List<Double> listAmplitude;
	
	
	public double getMatchValue(ModelOfEvaluate em, int flag){
		return EMAmplitude.GetMatchValue(this, em, flag);
	}
	
	public static double GetMatchValue(ModelOfEvaluate em1, ModelOfEvaluate em2, int flag){
		if(flag == 1){
			return ModelOfEvaluate.calPingFangCha(em1, em2);
		} else if(flag == 2){
			return ModelOfEvaluate.calMyMethod(em1, em2);
		} else if(flag == 3){
			return ModelOfEvaluate.calMyEntropy(em1, em2);
		} else if(flag == 4){
			return ModelOfEvaluate.calPearson(em1, em2);
		} else {
			System.out.println("get Match Value Error " + flag);
			return 0;
		}
	}

	
	public List<Double> getList() {
		return listAmplitude;
	}

}
