package calculate;

import java.util.ArrayList;
import java.util.List;

public class EMPercent extends ModelOfEvaluate {

	public EMPercent(List<Double> lgv){
		listGeneValue = lgv;
		listPercent = new ArrayList<Double>();
		double sum = 0.0;
		double max = 0.0;
		for(double d : listGeneValue){
			sum += d;
			if(d > max){
				max = d;
			}
		}
		for(double d : listGeneValue){
			//double per = d / sum;
			double per = d / max;
			listPercent.add(per);
		}
		
	}
	
	private List<Double> listGeneValue;
	
	private List<Double> listPercent;
	
	public List<Double> getList(){
		return listPercent;
	}
	
	public double getMatchValue(ModelOfEvaluate em, int flag){
		return EMPercent.GetMatchValue(this, em, flag);
	}
	
	public static double GetMatchValue(ModelOfEvaluate em1, ModelOfEvaluate em2, int flag){
		if(flag == 1){
			return ModelOfEvaluate.calPingFangCha(em1, em2);
		} else if(flag == 2){
			return ModelOfEvaluate.calMyMethod(em1, em2);
		} else if(flag == 3){
			return ModelOfEvaluate.calMyEntropy(em1, em2);
		} else if(flag == 4){
			return ModelOfEvaluate.calPearson(em1, em2);
		} else {
			System.out.println("get Match Value Error " + flag);
			return 0;
		}
	}

	
}
