package main;
import java.util.ArrayList;
import java.util.List;

import calculate.EMAmplitude;
import calculate.EMPercent;
import calculate.ModelOfEvaluate;


public class GeneMatch {

	
	public GeneMatch(String Gene, String Protein){
		gene = Gene;
		protein = Protein;
		lgv = new ArrayList<Double>();
	}
	
	private String gene;
	private String protein;
	
	private List<Double> lgv;
	
	//-----------------
	private ModelOfEvaluate perEva;
	private ModelOfEvaluate ampEva;
	
	public ModelOfEvaluate getPerEva(){
		return perEva;
	}
	public ModelOfEvaluate getAmpEva(){
		return ampEva;
	}
	//-----------------
	
	public String getProtein(){
		return protein;
	}
	public String getGeneAlias(){
		return gene;
	}
	public List<Double> getGeneValue(){
		return lgv;
	}
	
	public void setGeneValue(List<String> ListGeneValue){
		for(String s : ListGeneValue){
			lgv.add(new Double(s));
		}
		
		perEva = new EMPercent(lgv);
		ampEva = new EMAmplitude(lgv);
	}
	
}
