package main;
import java.util.Date;
import java.util.List;


public class MatrixMultiplyThread extends Thread {

	
	public MatrixMultiplyThread(int cur, int gap, int size,
			MatrixOfBioinfo list1, MatrixOfBioinfo list2, List<MatrixElement> targetList, boolean[] flagList){
		c = cur;
		s = size;
		g = gap;
		dl1 = list1;
		dl2 = list2;
		tl = targetList;
		flag = flagList;
	}
	
	
	private int c;
	private int g;
	private int s;
	private MatrixOfBioinfo dl1;
	private MatrixOfBioinfo dl2;
	private List<MatrixElement> tl;
	
	private boolean[] flag;	
	
	
	public void run(){
		Date d = new Date();
		for(int q = c; q < s; q += g){
			for(int w = 0; w < s; w++){
			    tl.get(MatrixOfBioinfo.getIndex(q, w, s)).setInfo(q, w, MatrixElement.getElementByMultiply(dl1, dl2, q, w).getValue());
			}
			
			//System.out.println("------" + q);
		}
		System.out.println("Thread" + c + "--" + (d.getTime() - new Date().getTime()) / 1000);
		flag[c] = true;
	}	
	
	
	
	
	
	
	
}
